#ifndef BONECO_H_INCLUDED
#define BONECO_H_INCLUDED

#include "allegro.h"

void movimento_boneco (void * parametro);
void pular (void * parametro);
int calc_posicao (int v_inicial, int gravidade, float tempo);

class boneco
{
public:
    boneco(char nome[], int tipo_boneco, int pos_x, int pos_y, int vel_pulo, int vel_andar, int q_andar, int q_pular, int qnt_atacar, int distancia_corte, int distancia_corte_atacar, int altura, int g, int l, int atq);
    ~boneco();

    char nome[50];

    int posicao_x;
    int posicao_y;

    int colisao[4];

    int tamanho_x;
    int tamanho_y;

    int margem_x;
    int margem_y;

    int posicao_array; //posicao no array de objetos, -1 significa que nao est

    int tipo; //0 = computador, 1 = player1, 2 = player2

    int quant_andar; // Quantidade de Sprites de andar pra direita ou esquerda
    int quant_pular; // Quantidade de sprites de pulo
    int quant_ataque;

    int velocidade_andar;

    int pulando; //se o personagem esta pulando

    int pos_pular_d; //posicao no array onde comea os sprites de pulo pra direita
    int pos_pular_e; //posicao no array onde comea os sprites de pulo pra esquerda
    int pos_andar_d; //posicao no array onde comea os sprites de andar pra direita
    int pos_andar_e; //posicao no array onde comea os sprites de andar pra esquerda

    int d; //Variavel para varrer os sprites de andar para a direita
    int e; //Variavel para varrer os sprites de andar para a esquerda

    int direcao; //direcao que o boneco esta virado 1 = direita 2 = esquerda

    BITMAP ** imagens; // imagens vai guardar todos os sprites do boneco
    BITMAP ** ataque; //array com os sprites de ataque
    BITMAP * bmp; //bitmap do boneco a ser exibido na tela

    typedef struct variaveis_pulo
    {
        float tempo_inicial; //tempo inicial do pulo
        float tempo_decorrido;
        float duracao; //tempo de duracao do pulo
        int incremento_x; // Vai servir pra avisar a funcao pular se  pra esquerda, direita ou cima
        int vel_inicial; // velocidade inicial de pulo
        int posicao_inicial_x;
        int posicao_inicial_y;
        int velocidade_inicial_y;
        int velocidade_inicial_x;
    } PULO;

    PULO pulo;

    int teclado[10];
    int atacando;
    int atacado;
    int caindo;
    int a; //para varrer os sprites de ataque

    int life;
    int tirar_life;
    int dano;
    int area_visao;
};

#endif // BONECO_H_INCLUDED
