#include "classe_jogo.h"
#include "globais.h"
#include <iostream>
using std::cout;

#define NAO_PULANDO (!principal->array.objetos[x]->pulando && !principal->array.objetos[y]->pulando)
#define ATACANDO (principal->array.objetos[x]->atacando || principal->array.objetos[y]->atacando)
#define DOIS_INIMIGOS(X,Y) (!principal->array.objetos[X]->tipo && !principal->array.objetos[Y]->tipo)
#define DOIS_PERSONAGENS(X,Y) (principal->array.objetos[X]->tipo && principal->array.objetos[Y]->tipo)

int POSICAO_DIREITA (int A)
{
    return(principal->array.objetos[A]->posicao_x + principal->array.objetos[A]->tamanho_x - principal->array.objetos[A]->margem_x);
}

int POSICAO_ESQUERDA (int A)
{
    return(principal->array.objetos[A]->posicao_x + principal->array.objetos[A]->margem_x);
}

int POSICAO_CIMA (int A)
{
    return(principal->array.objetos[A]->posicao_y + principal->array.objetos[A]->margem_y);
}

int POSICAO_BAIXO (int A)
{
    return(principal->array.objetos[A]->posicao_y + principal->array.objetos[A]->tamanho_y - principal->array.objetos[A]->margem_y);
}

int mesma_profundidade (int b1, int b2)
{
    if (POSICAO_BAIXO(b1) > POSICAO_BAIXO(b2) - 25 && POSICAO_BAIXO(b1) < POSICAO_BAIXO(b2) + 25)
    {
        return(1);
    }
    else if (POSICAO_BAIXO(b2) > POSICAO_BAIXO(b1) - 25 && POSICAO_BAIXO(b2) < POSICAO_BAIXO(b1) + 25)
    {
        return(1);
    }
    return(0);
}

int mesma_linha (int b1, int b2)
{
    if (POSICAO_DIREITA(b1) > POSICAO_ESQUERDA(b2) && POSICAO_DIREITA(b1) < POSICAO_DIREITA(b2))
    {
//        //cout << "mesma linha\n";
        return(1);
    }
    else if (POSICAO_ESQUERDA(b1) > POSICAO_ESQUERDA(b2) && POSICAO_ESQUERDA(b1) < POSICAO_DIREITA(b2))
    {
//        //cout << "mesma linha\n";
        return(1);
    }
    return(0);
}

int area_ataque (int b1, int b2)
{
    if (POSICAO_DIREITA(b1) > POSICAO_ESQUERDA(b2) - 30 && POSICAO_DIREITA(b1) < POSICAO_DIREITA(b2))
    {
        return(1);
    }
    else if (POSICAO_ESQUERDA(b1) > POSICAO_ESQUERDA(b2) + 30 && POSICAO_ESQUERDA(b1) < POSICAO_DIREITA(b2))
    {
        return(1);
    }
    return(0);
}

void colisao (void)
{
    for (int x = 0 ; x < principal->array.num ; x++) //reseta as colisoes
    {
        for (int y = 0 ; y < 4 ; y++)
        {
            principal->array.objetos[x]->colisao[y] = 0;
        }
    }

    for (int x = 0 ; x < principal->array.num ; x++)
    {
        for (int y = 0 ; y < principal->array.num ; y++)
        {
            if (x == y)
            {
                continue;
            }
            if (NAO_PULANDO)
            {
                if (mesma_profundidade(x,y))
                {
                    if (POSICAO_DIREITA(x) >= POSICAO_ESQUERDA(y) && POSICAO_DIREITA(x) <= POSICAO_DIREITA(y))  //colidindo pela direita
                    {
                        principal->array.objetos[x]->colisao[0] = 1; //x pela direita
                        if (principal->array.objetos[y]->atacando && !DOIS_INIMIGOS(x,y) && !DOIS_PERSONAGENS(x,y) && area_ataque(x,y))
                        {
                            principal->array.objetos[x]->atacado = 1;
                            principal->array.objetos[x]->tirar_life = principal->array.objetos[y]->dano;
                        }
                        //principal->array.objetos[x]->posicao_x -= principal->array.objetos[x]->velocidade_andar;

                        principal->array.objetos[y]->colisao[1] = 1; //y pela esquerda
                        if (principal->array.objetos[x]->atacando && !DOIS_INIMIGOS(x,y) && !DOIS_PERSONAGENS(x,y) && area_ataque(x,y))
                        {
                            principal->array.objetos[y]->atacado = 2;
                            principal->array.objetos[y]->tirar_life = principal->array.objetos[x]->dano;
                        }
                        //principal->array.objetos[y]->posicao_x += principal->array.objetos[y]->velocidade_andar;
//                        //cout << principal->array.objetos[x]->nome << " colidiu pela direita\n";
                    }
                    else if (POSICAO_ESQUERDA(x) <= POSICAO_DIREITA(y) && POSICAO_ESQUERDA(x) >= POSICAO_ESQUERDA(y)) //colidindo pela esquerda
                    {
                        principal->array.objetos[x]->colisao[1] = 1;
                        if (principal->array.objetos[y]->atacando)
                        {
                            principal->array.objetos[x]->atacado = 2;
                            principal->array.objetos[x]->tirar_life = principal->array.objetos[y]->dano;
                        }
                        //principal->array.objetos[x]->posicao_x += principal->array.objetos[x]->velocidade_andar;

                        principal->array.objetos[y]->colisao[0] = 1;
                        if (principal->array.objetos[x]->atacando)
                        {
                            principal->array.objetos[y]->atacado = 1;
                            principal->array.objetos[y]->tirar_life = principal->array.objetos[x]->dano;
                        }
                        //principal->array.objetos[y]->posicao_x -= principal->array.objetos[y]->velocidade_andar;
//                        //cout << principal->array.objetos[x]->nome<<" colidiu pela esquerda\n";
                    }
                }
                else if (mesma_linha(x,y))
                {
                    if (POSICAO_CIMA(x) <= POSICAO_BAIXO(y) && POSICAO_CIMA(x) >= POSICAO_CIMA(y) && POSICAO_BAIXO(x) > POSICAO_BAIXO(y)) //colidiu por cima
                    {
                        principal->array.objetos[x]->colisao[2] = 1; //x colidiu por cima
                        principal->array.objetos[y]->colisao[3] = 1; //y colidiu por baixo
//                        //cout << principal->array.objetos[x]->nome <<" colidiu por cima\n";
                    }
                    else if (POSICAO_BAIXO(x) >= POSICAO_CIMA(y) && POSICAO_BAIXO(x) <= POSICAO_BAIXO(y) && POSICAO_CIMA(x) > POSICAO_CIMA(y)) //colidiu por baixo
                    {
                        principal->array.objetos[x]->colisao[3] = 1;
                        principal->array.objetos[y]->colisao[2] = 1;
//                       //cout << principal->array.objetos[x]->nome<< " colidiu por baixo\n";
                    }
                }
            }
        }
    }
}
