#include "globais.h"
#include "math.h"
#include "colisao.h"
#include "menu.h"
#include <iostream>
using std::cout;
#include "defines.h"
#define MENOR(A,B) (A < B) ? A : B

//TECLADO DO INIMIGO:
//teclado[0] = cima
//teclado[1] = baixo
//teclado[2] = direita
//teclado[3] = esquerda
//teclado[4] = corre
//teclado[5] = pula
//teclado[6] = ataque

//COLISAO:
//colisao[0] = direita
//colisao[1] = esquerda
//colisao[2] = cima
//colisao[3] = baixo

int distancia (int p1, int p2) //retorna a distancia entre os objetos de posicao p1 e p2 no array
{
    int dist_x = principal->array.objetos[p1]->posicao_x - principal->array.objetos[p2]->posicao_x;
    int dist_y = principal->array.objetos[p1]->posicao_y - principal->array.objetos[p2]->posicao_y;
    int dist = (int) sqrt(pow(dist_x,2) + pow(dist_y,2));
    return(dist);
}

void perseguir (void * parametro)
{
    boneco * inimigo = (boneco*) parametro;

    static int posicao = 0;
    static int aproximando = 0;
    int menor_dist = 0;
    static int flag_tempo =0 ;
    static float tempo_inicial;

    if (principal->tipo == 1)
    {
        if (principal->posicao_p1 >= 0)
        {
            menor_dist = distancia(inimigo->posicao_array, principal->posicao_p1);
            posicao = principal->posicao_p1;
        }
        else
        {
            principal->cenario->bmp = load_bitmap("gameover.bmp", NULL);
            blit(principal->cenario->bmp , screen, 0, 0, 0, 0, MAX_X, MAX_Y);
            rest(500);
            principal->sair = 1;
        }
    }
    else if (principal->posicao_p1 >= 0 && principal->posicao_p2 >= 0) //se tiver 2 players escolhe o mais proximo
    {
        //cout<< "2 players vivos\n";
//        //cout<< "life player 1 ( " << principal->array.objetos[principal->posicao_p1]->nome << " )" << principal->array.objetos[principal->posicao_p1]->life <<"\n";
//        //cout<< "life player 2:( " << principal->array.objetos[principal->posicao_p2]->nome << " ) " <<principal->array.objetos[principal->posicao_p2]->life <<"\n";
        int dist_player1 = distancia(inimigo->posicao_array, principal->posicao_p1);
        int dist_player2 = distancia(inimigo->posicao_array, principal->posicao_p2);
        (dist_player1 < dist_player2) ? posicao = principal->posicao_p1 : posicao = principal->posicao_p2;
        menor_dist = MENOR(dist_player1,dist_player2);
    }
    else if (principal->posicao_p1 >= 0)
    {
        //cout<< " player 1 vivo \n";
        menor_dist = distancia(inimigo->posicao_array, principal->posicao_p1);
        posicao = principal->posicao_p1;
    }
    else if (principal->posicao_p2 >= 0)
    {
        //cout<< " player 2 vivo \n";
        menor_dist = distancia(inimigo->posicao_array, principal->posicao_p2);
        posicao = principal->posicao_p2;
    }
    else
    {
        principal->cenario->bmp = load_bitmap("gameover.bmp", NULL);
        rest(500);
        blit(principal->cenario->bmp , screen, 0, 0, 0, 0, MAX_X, MAX_Y);
        principal->sair = 1;
    }

    inimigo->teclado[0] = 0;
    inimigo->teclado[1] = 0;
    inimigo->teclado[2] = 0;
    inimigo->teclado[3] = 0;
    inimigo->teclado[4] = 0;
    inimigo->teclado[5] = 0;
    inimigo->teclado[6] = 0;


    if (inimigo->area_visao < menor_dist)
        return;

//    if (inimigo->atacando || inimigo->atacado)
//        return;

//    printf("perseguindo %s\n",principal->array.objetos[posicao]->nome);

    if ((inimigo->colisao[2] || inimigo->colisao[3])) //colidindo por baixo ou por cima
    {
        if (inimigo->posicao_x < MAX_X - 300 && aproximando == 0)
            aproximando = 2; //pela direita
        else if (aproximando == 0)
            aproximando = 3; //pela esquerda
        inimigo->teclado[aproximando] = 1;
    }
    else
    {
        aproximando = 0;
        inimigo->teclado[aproximando] = 0;
    }

    if (!mesma_profundidade(inimigo->posicao_array, posicao) && !principal->array.objetos[posicao]->pulando)
    {
        if (POSICAO_BAIXO(inimigo->posicao_array) < POSICAO_BAIXO(principal->array.objetos[posicao]->posicao_array) - 15)
        {
            inimigo->teclado[1] = 1;
        }
        if (POSICAO_BAIXO(inimigo->posicao_array) > POSICAO_BAIXO(principal->array.objetos[posicao]->posicao_array) + 15)
        {
            inimigo->teclado[0] = 1;
        }
    }

    if (inimigo->posicao_x + inimigo->tamanho_x < principal->array.objetos[posicao]->posicao_x - 10 && !inimigo->colisao[0])
    {
        inimigo->teclado[2] = 1;
        flag_tempo =0;
    }

    else if (inimigo->posicao_x > principal->array.objetos[posicao]->posicao_x + principal->array.objetos[posicao]->tamanho_x + 10 && !inimigo->colisao[1])
    {
        inimigo->teclado[3] = 1;
        flag_tempo =0;
    }
    else //acerta a direao do boneco dps que chegou no inimigo
    {
        if (inimigo->posicao_x > principal->array.objetos[posicao]->posicao_x)
        {
            inimigo->teclado[3] = 1;
            inimigo->direcao = 2;
        }
        else
        {
            inimigo->teclado[2] = 1;
            inimigo->direcao = 1;
        }

        if ( flag_tempo == 0 )
        {
            tempo_inicial = principal->tempo;
            flag_tempo = 1;
        }
        if ( principal->tempo - tempo_inicial >  0.2 )
        {
            inimigo->teclado[2] = 0;
            inimigo->teclado[3] = 0;
            inimigo->teclado[6] = rand()%2;
            flag_tempo = 0;
        }
    }
}
