#include "globais.h"
#include "sort.h"
#include <iostream>
using std::cout;

int posicao (boneco ** objetos, int i)
{
    return(objetos[i]->posicao_y + objetos[i]->tamanho_y);
}

void bubblesort (boneco ** objetos, int num)
{
    for (int x = 0; x < num ; x++)
    {
        for (int y = x+1; y < num ;y++)
        {
            if (posicao(objetos, y) < posicao(objetos, x) && !objetos[x]->pulando && !objetos[y]->pulando)
            {
                ////cout << "trocando " << x << " com " << y << "\n";
                troca(objetos, x, y);
            }
        }
    }
}

void quicksort (boneco ** objetos, int left, int right)
{
    if (right > left)
    {
        int pivo = mediana(objetos,left,right);
        int pivonovo = particao(objetos, left, right, pivo);

        quicksort(objetos, left, pivonovo-1);
        quicksort(objetos, pivonovo+1, right);
    }
}

int mediana (boneco ** objetos, int left, int right)
{
    int center = (left+right)/2;

    if (posicao(objetos, center) < posicao(objetos, left))
        troca(objetos, left, center);

    if (posicao(objetos, right) < posicao(objetos, left))
        troca(objetos, left, right);

    if (posicao(objetos, right) < posicao(objetos, center))
        troca(objetos, center, right);

    troca(objetos, center, right-1);

    return(center);
}

int particao (boneco ** objetos, int left, int right, int pivo)
{
    int valorpivo = posicao(objetos, pivo);

    troca(objetos, pivo, right);
    int index = left;

    for (int i = left; i < right; i++)
    {
        if (posicao(objetos, i) < valorpivo)
        {
            troca(objetos, i, index);
            index++;
        }
    }

    troca(objetos, index, right);

    return(index);
}

void troca (boneco ** objetos, int pos1, int pos2)
{
    if (objetos[pos1]->pulando || objetos[pos2]->pulando)
        return;

    if (objetos[pos1]->tipo)
    {
        if (objetos[pos1]->tipo == 1)
        {
            principal->posicao_p1 = pos2;
        }
        else
        {
            principal->posicao_p2 = pos2;
        }
    }

    if (objetos[pos2]->tipo)
    {
        if (objetos[pos2]->tipo == 1)
        {
            principal->posicao_p1 = pos1;
        }
        else
        {
            principal->posicao_p2 = pos1;
        }
    }

    boneco *temp = objetos[pos1];
    objetos[pos1]->posicao_array = pos2;
    objetos[pos2]->posicao_array = pos1;
    objetos[pos1] = objetos[pos2];
    objetos[pos2] = temp;
}
